# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import popuplib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

names = {'godmode':'Godmode','noclip':'Noclip','freeze':'Freeze'}

langs = {
		'godmode':{1:'godmode_target_isgod',2:'godmode_target_isnotgod'},
		'noclip':{1:'noclip_target_cliped',2:'noclip_target_uncliped'},
		'freeze':{1:'freeze_target_frozen',2:'freeze_target_unfrozen'}
		}

m = None

def load():
	### CREATE PLAYERS VAR ###
	for x in names:
		for ply in playerlib.getPlayerList('#all'):
			var = es.ServerVar('sam_%s_%s' % (x,ply.steamid))
			var.set(0)

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	### UNCLIP PLAYERS ###
	for x in names:
		for ply in playerlib.getPlayerList('#all'):
			targetvar = es.ServerVar('sam_%s_%s' % (x,ply.steamid))
			if int(targetvar) == 1: undo_action(ply, x)

	### Popups ###
	func.popupDelete('getPlayerList')

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, module):
	global m
	m = module
	alive = playerlib.getPlayerList('#alive')
	if len(alive) > 0:
		func.popupDelete('getPlayerList')
		popup = popuplib.easymenu('getPlayerList', None, goToAction)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s\n# %s' % (func.lang_titles('pcontrol_%s' % m), func.lang_titles('pcontrol_%s_desc' % m)))
		popup.submenu(10, 'pcontrol')
		for ply in alive: popup.addoption(ply, ply.name)
		popup.send(userid)
	else:
		func.sendMenu(userid, 'pcontrol')
		func.lang_pcontrol('empty_teams')

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def goToAction(userid, choice, popup):
	target = choice
	if admins.checkImmunity(es.getplayersteamid(userid), target.steamid):
		targetvar = es.ServerVar('sam_%s_%s' % (m, target.steamid))
		if int(targetvar) != 1:
			do_action(target, m)
			func.tell('#all', func.lang_pcontrol(langs[m][1], {'target':target.name}))
		else:
			undo_action(target, m)
			func.tell('#all', func.lang_pcontrol(langs[m][2], {'target':target.name}))
	block.pcontrol_Choice(userid, names[m], None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def do_action(target, module):
	targetvar = es.ServerVar('sam_%s_%s' % (module,target.steamid))
	targetvar.set(1)
	if module == 'noclip': target.noclip(1)
	elif module == 'godmode': target.godmode(1)
	elif module == 'freeze': target.freeze(1)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def undo_action(target, module):
	targetvar = es.ServerVar('sam_%s_%s' % (module,target.steamid))
	targetvar.set(0)
	if module == 'noclip': target.noclip(0)
	elif module == 'godmode': target.godmode(0)
	elif module == 'freeze': target.freeze(0)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	for x in names:
		var = es.ServerVar('sam_%s_%s' % (x,ev['userid']))
		var.set(0)

# ============================================================================================================================================================== #