# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import cfglib
import os
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')

# * VARIABLES

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Files Blocks ###
	reasons_file()
	config_file()

	es.unload('sam/functions/cfg')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def config_file():
	langs = []
	for item in func.langs:
		item = item.strip('"')
		item = item.replace(item[0],item[0].upper())
		langs.append(str(item))
	if os.path.isfile('cstrike/cfg/sam/config.cfg') == False: 
		cfg = cfglib.AddonCFG('cstrike/cfg/sam/config.cfg')
		cfg.text('-' * 80)
		cfg.text(' # Source Admin Menu | Configuration File')
		cfg.text(' ')
		cfg.text('-' * 80)
		cfg.cvar('sam_language',   'english',           'Script language. Available langs: %s.' % (','.join(langs)))
		cfg.cvar('sam_menu_title', 'Source Admin Menu', 'Menus title.')
		cfg.cvar('sam_chat_tag',   '#redSAM',           'Tag of the beggining of any SAM message.')
		cfg.write()
	es.ServerCommand('exec sam/config.cfg')

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def reasons_file():
	if os.path.isfile('cstrike/cfg/sam/reasons.txt') == False: 
		f = open('cstrike/cfg/sam/reasons.txt','w')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write('#  Source Admin Menu # Reasons file  \n')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write('# \n')
		f.write('#   - In this file you can add all the reasons\n')
		f.write('#  you wish to give when a player is to be banned.\n')
		f.write('# \n')
		f.write('#  To add a reason follow this example:\n')
		f.write('#  EXP: "- You deserved it!"\n')
		f.write('#  Note: the - must be there, or else it wont work.\n')
		f.write('# \n')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write(' \n')
		f.write('- Disrespecting admins\n')
		f.write('- Disrespecting Server rules\n')
		f.write('- Chat spaming / Micro noise\n')
		f.write('- Cheating with Aimbot\n')
		f.write('- Cheating with SpeedHack\n')
		f.write('- Cheating with wallhack\n')

# ============================================================================================================================================================= #