# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import popuplib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

respawntag = '#greenRESPAWN'

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload(): func.popupDelete('respawn_plist')

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid):
	alive    = playerlib.getPlayerList('#alive')
	_dead    = playerlib.getPlayerList('#dead')
	dead     = []
	for x in _dead:
		if x.teamid != 1: dead.append(x)
	if len(alive) > 0 or len(dead) > 0:
		func.popupDelete('respawn_plist')
		popup = popuplib.easymenu('respawn_plist', None, respawnTarget)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s\n# %s' % (func.lang_titles('pcontrol_respawn'), func.lang_titles('pcontrol_respawn_desc')))
		popup.submenu(10, 'pcontrol')
		for x in (alive, dead):
			for ply in x: popup.addoption(ply, ply.name)
		popup.send(userid)
	else:
		func.hudhint(userid, func.lang_pcontrol('empty_teams'))
		func.sendMenu(userid, 'pcontrol')

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def respawnTarget(userid, target, popup):
	if admins.checkImmunity(es.getplayersteamid(userid), target.steamid):
		es.setplayerprop(target, 'CCSPlayer.m_iPlayerState', 0)
		es.setplayerprop(target, 'CCSPlayer.baseclass.m_lifeState', 512)
		es.spawnplayer(target)
		func.tell('#all', func.lang_pcontrol('respawn_target_respawned', {'target':target.name}), respawntag)
	moduleAction(userid)

# ============================================================================================================================================================== #
